#include <iostream>
#include <direct.h>
#include <afx.h>



int main()
{
	
	// Create security attributes needed to create pipe 
	HANDLE hChildStdoutRd;
	HANDLE hChildStdoutWr;
	SECURITY_ATTRIBUTES saAttr = { sizeof(SECURITY_ATTRIBUTES) } ;
	saAttr.bInheritHandle  = TRUE; 
	saAttr.lpSecurityDescriptor = NULL;
	
	// Create pipe to get results from child's stdout.	
	if ( !CreatePipe( &hChildStdoutRd, &hChildStdoutWr, &saAttr, 0 ) )
	{
		return 1;
	}
	
	CString l_strFileName = "small.mp4";
	CString l_strPathName = "C:\\MyStuff";
	CString l_strFfprobePath = "ffprobe.exe";	
	CString l_strParameters = " -sexagesimal -v quiet -print_format xml -show_format -i " + l_strFileName;	

	PROCESS_INFORMATION pif  = { 0 };
	STARTUPINFO si = { sizeof(STARTUPINFO) }; 

	ZeroMemory( &si,sizeof( si ) );   
	si.cb = sizeof( si );  
	si.dwFlags	   = STARTF_USESHOWWINDOW | STARTF_USESTDHANDLES;
	si.hStdOutput  = hChildStdoutWr;
	si.hStdError   = hChildStdoutWr;
	si.wShowWindow = SW_HIDE;

	BOOL bRet = CreateProcess(
						l_strFfprobePath.GetBuffer(0),			// Path to ffprobe executable
						l_strParameters.GetBuffer(0),			// Command parameters string
						NULL,									// Process handle not inherited
						NULL,									// Thread handle not inherited
						TRUE,									// Inheritance of handles
						CREATE_NO_WINDOW,						// Suppress console window
						NULL,									// Same environment block as this prog
						l_strPathName,							// Current directory
						&si,									// Pointer to STARTUPINFO
						&pif );									// Pointer to PROCESS_INFORMATION

	if( bRet == FALSE )
	{		
		return false;
	}

	// Wait until child processes exit, but not forever.  Terminate if still running.
	WaitForSingleObject( pif.hProcess, 4000 );
	TerminateProcess( pif.hProcess, 0 );

	// Close the write end of the pipe before reading from the read end of the pipe.
	if ( !CloseHandle( hChildStdoutWr ) )
	{
		return false;
	}

	// Read output from the child process.
	CString l_strResult;
	for ( ;; )
	{
		DWORD l_dwRead;
		CHAR l_chBuffer[ 4096 ];
				
		bool l_fIsDone = !ReadFile( hChildStdoutRd, l_chBuffer, 4096, &l_dwRead, NULL) || l_dwRead == 0;
		
		if( l_fIsDone ) break;
				
		l_strResult += CString( l_chBuffer, l_dwRead) ;
	}

	CloseHandle( hChildStdoutRd );
	CloseHandle( pif.hProcess );  
	CloseHandle( pif.hThread );    

	// Parse the resulting XML and extract its media type
	const CString l_strDelimiter = "</ffprobe>";
	const int l_nLength = l_strDelimiter.GetLength();
	int pos = l_strResult.Find( "</ffprobe>" );
	CString l_strSubstr = l_strResult.Left( pos + l_nLength );

	std::cout << l_strSubstr << std::endl;

	std::getchar();
	return 0;
}